package com.monnit.mine.SampleMineApplication;

import java.net.*;
import java.util.ArrayList;
import java.util.List;

import com.monnit.mine.BaseApplication.ExtensionMethods.Extensions;
import com.monnit.mine.MonnitMineAPI.Gateway;
import com.monnit.mine.MonnitMineAPI.MineServer;
import com.monnit.mine.MonnitMineAPI.Sensor;
import com.monnit.mine.MonnitMineAPI.enums.eGatewayType;
import com.monnit.mine.MonnitMineAPI.enums.eMineListenerProtocol;
import com.monnit.mine.MonnitMineAPI.enums.eSensorApplication;
import javax.crypto.spec.*;

public class GUIListenerFunctions {
	private static MineServer _Server;
	
	public static synchronized void print(String s) {
//		if(!lock) {
//			lock = true;
			gui.println(s);
			System.out.println(s);
/*			lock = false;
		}
		else {
			try{
				Thread.sleep(100);
			}
			catch (Exception e) {
				e.printStackTrace();
			}
			print(s);
		}*/
	}
	
	public static void startButtonPressed() throws Exception {
		int port = getPort();
		if(port < 1) {
			gui.println("Invalid Port Number.");
			return;
		}
		eMineListenerProtocol Protocol;
		try {
			Protocol = eMineListenerProtocol.valueOf(gui.protocolDropdown.getSelectedItem().toString());
		}
		catch (Exception e) {
			print("Invalid Protocol");
			return;
		}
		
		InetAddress ip = InetAddress.getByName(gui.ipDropdown.getSelectedItem().toString());//stringToByteIP(gui.ipDropdown.getSelectedItem().toString()));
		
		_Server = new MineServer(Protocol, ip, port);
		print("Constructed Server.");
		_Server.StartServer();
		print("Server started.");
		
		if(_Server.addGatewayDataProcessingHandler(new GatewayMessageHandler())) print("Added GatewayHandler.");
		else print("Failed to add handler.");
		if(_Server.addSensorDataProcessingHandler(new SensorMessageHandler())) print("Added SensorHandler.");
		else print("Failed to add handler.");
		if(_Server.addExceptionProcessingHandler(new ExceptionHandler())) print("Added ExceptionHandler.");
		else print("Failed to add handler.");
		if(_Server.addPersistSensorHandler(new PersistSensorHandler())) print("Added PersistSensorHandler.");
		else print("Failed to add handler.");
		if(_Server.addPersistGatewayHandler(new PersistGatewayHandler())) print("Added PersistGatewayHandler.");
		else print("Failed to add handler.");
		if(_Server.addUnknownGatewayHandler(new UnknownGatewayHandler(_Server))) print("Added UnknownGatewayHandler.");
		else print("Failed to add handler.");
		
		ResponseHandler responseHandler = new ResponseHandler();
		_Server.addGatewayResponseHandler(responseHandler);

		///////////////////////////////////////////////////////////
		//         Ad-hoc sensors and gateways
		///////////////////////////////////////////////////////////
		
		Gateway ethGate;
		ethGate = new Gateway(
			101908,
			eGatewayType.Ethernet_3_0,
			new SecretKeySpec(new byte[] {
					(byte) 0x11,
					(byte) 0x11,
					(byte) 0x11,
					(byte) 0x11,
					(byte) 0x11,
					(byte) 0x11,
					(byte) 0x11,
					(byte) 0x11,
					(byte) 0x11,
					(byte) 0x11,
					(byte) 0x11,
					(byte) 0x11,
					(byte) 0x11,
					(byte) 0x11,
					(byte) 0x11,
					(byte) 0x11,
			}, "AES")
		);

		
		List<Sensor> sensList = new ArrayList<Sensor>();
		//Gateway usbGate = new Gateway(
		//		9596,
		//		eGatewayType.USB,
		//		3000
		//		);
		sensList.add( new Sensor(
				811,
				eSensorApplication.Button,
				"2.2.0.0"
				));
		sensList.add(new Sensor(
				543,
				eSensorApplication.Humidity,
				"2.2.0.0"
				));
		sensList.add(new Sensor(
				505,
				eSensorApplication.Activity_Detection,
				"2.3.0.0"
				));
		sensList.add(new Sensor(
				204,
				eSensorApplication.Water_Detection,
				"2.3.0.0"
				));
		sensList.add(new Sensor(
				542,
				eSensorApplication.Activity_Timer,
				"2.3.0.0"
				));
		sensList.add(new Sensor(
				503,
				eSensorApplication.Dry_Contact,
				"2.3.0.0"
				));
		sensList.add(new Sensor(
				584,
				eSensorApplication.DuctTemperature,
				"2.3.0.0"
				));
		sensList.add(new Sensor(
				546,
				eSensorApplication.Low_Temperature,
				"2.3.0.0"
				));
		sensList.add(new Sensor(
				565,
				eSensorApplication.Low_Temperature,
				"2.3.0.0"
				));
		sensList.add(new Sensor(
				72390,
				eSensorApplication.Infared_Motion,
				"2.3.0.0"
				));
		sensList.add(new Sensor(
				509,
				eSensorApplication.Open_Closed,
				"2.3.0.0"
				));
		sensList.add(new Sensor(
				535,
				eSensorApplication.High_Temperature,
				"2.3.0.0"
				));
		sensList.add(new Sensor(
				245,
				eSensorApplication.SmartRangerBase,
				"2.3.0.0"
				));
		sensList.add(new Sensor(
				502,
				eSensorApplication.Temperature,
				"2.3.0.0"
				));
		
		
				
		_Server.RegisterGateway(ethGate);
		for(Sensor s : sensList) {
			_Server.RegisterSensor(ethGate.GatewayID, s);
		}
		
		print("Finished all inits");
	}
	
	private static int getPort() {
		try {
			return Integer.parseInt(gui.portField.getText());
		}
		catch (Exception e) {
			return -1;
		}
	}
	
	public static void RegisterGateway() throws Exception {
		int gid = getGid();
		if(gid > 0) {
			eGatewayType egt = eGatewayType.valueOf(gui.gType.getSelectedItem().toString());
			int port = getPort();
			Gateway gate = new Gateway(
					gid,
					egt,
					"2.2.0.0",
					"3.0.0.0",
					"0.0.0.0",
					port
					);
			_Server.RegisterGateway(gate);
			print("Gateway " + gid + " registered.");
		}
	}
	
	public static void RemoveGateway() throws InterruptedException {
		int gid = getGid();
		if(gid > 0) {
			_Server.RemoveGateway(gid);
			print("Gateway " + gid + " removed.");
		}
	}
	
	public static void registerSensor() throws Exception {
		int sid = getSid();
		if(sid > 0) {
			eSensorApplication esa = eSensorApplication.valueOf(gui.sType.getSelectedItem().toString());
			
			Sensor sens = new Sensor(sid, esa, "2.2.0.0");
			try {
				int gid = getGid();
				if(gid > 0) {
					_Server.RegisterSensor(gid, sens);
					print("Sensor " + sid + " registered.");
				}
				else {
					print("Invalid GatewayID.");
				}
			}
			catch (Exception e) {
				System.out.println(e.toString());
				GUIListenerFunctions.print("Failed to register sensor.");
			}
		}
	}
	
	public static void removeSensor() throws InterruptedException {
		int sid = getSid();
		if(sid > 0) {
			_Server.RemoveSensor(sid);
			print("Sensor " + sid + " has been removed.");
		}
	}
	
	public static void FindSensor() throws InterruptedException {
		int sid = getSid();
		if(sid > 0) {
			Sensor sens = _Server.FindSensor(sid);
			FindSensorPopup pop = new FindSensorPopup(sens);
		}
	}
	
	public static void FindGateway() {
		int gid = getGid();
		if(gid > 0) {
			Gateway gate = _Server.FindGateway(gid);
			FindGatewayPopup pop = new FindGatewayPopup(gate);
		}
	}
	
	public static int getSid() {
		int sid;
		try {
			sid = Integer.parseInt(gui.sid.getText());
		}
		catch (Exception e) {
			gui.println(e.toString());
			gui.println("Invalid SensorID");
			return -1;
		}
		return sid;
	}
	
	public static int getGid() {
		int gid;
		try {
			gid = Integer.parseInt(gui.gid.getText());
		}
		catch (Exception e) {
			gui.println("Invalid GatewayID.");
			return -1;
		}
		return gid;
	}
	
	public static byte[] stringToByteIP(String ip) {
		byte[] bip = new byte[4];
		String[] iparray = ip.split("\\.");
		for(int i=0; i<bip.length; i++) {
			bip[i] = (byte) Integer.parseInt(iparray[i]);
		}
		return bip;
	}

	public static void ReformNetwork() {
		Gateway gate = _Server.FindGateway(getGid());
		if(gate !=null) {
			gate.ReformNetwork();
			GUIListenerFunctions.print("Reform pending.");
		}
		else {
			GUIListenerFunctions.print("Gateway does not exist.");
		}
	}

	public static void SendSensorList() {
		Gateway gate = _Server.FindGateway(getGid());
		Extensions.debug("This doesn't do anything (yet).", 20);
	}
}
