package com.monnit.mine.MineToCommand;

import java.io.InputStream;
import java.io.OutputStream;
import java.net.InetAddress;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

import javax.crypto.spec.SecretKeySpec;

import com.monnit.mine.BaseApplication.BitConverter;
import com.monnit.mine.BaseApplication.ExtensionMethods.Extensions;
import com.monnit.mine.BaseApplication.applicationclasses.Control_1Base;
import com.monnit.mine.MonnitMineAPI.*;
import com.monnit.mine.MonnitMineAPI.enums.*;

public class MineToCommand {
	static int port = 3001;
	static MineServer _Server;

	public static void main(String[] args) {
		eMineListenerProtocol Protocol;
		try {
			Protocol = eMineListenerProtocol.TCP;
			InetAddress ip = InetAddress.getByName("0.0.0.0");
			
			_Server = new MineServer(Protocol, ip, port);
			_Server.StartServer();
			System.out.println("Constructed Server.");
			
			if(_Server.addGatewayDataProcessingHandler(new GatewayMessageHandler())) System.out.println("Added GatewayHandler.");
			else System.out.println("Failed to add handler.");
			if(_Server.addSensorDataProcessingHandler(new SensorMessageHandler(_Server))) System.out.println("Added SensorHandler.");
			else System.out.println("Failed to add handler.");
			if(_Server.addExceptionProcessingHandler(new ExceptionHandler())) System.out.println("Added ExceptionHandler.");
			else System.out.println("Failed to add handler.");
			if(_Server.addPersistSensorHandler(new PersistSensorHandler())) System.out.println("Added PersistSensorHandler.");
			else System.out.println("Failed to add handler.");
			if(_Server.addPersistGatewayHandler(new PersistGatewayHandler())) System.out.println("Added PersistGatewayHandler.");
			else System.out.println("Failed to add handler.");
			
			
			///////////////////////////////////////////////////////////
			//         Ad-hoc sensors and gateways
			///////////////////////////////////////////////////////////
			
			Gateway usbGate = new Gateway(
					9596,
					eGatewayType.USB
					);
			Sensor lux = new Sensor(
					227,
					eSensorApplication.Light_Detection,
					"2.3.0.0"
					);
			_Server.RegisterGateway(usbGate);
			_Server.RegisterSensor(usbGate.GatewayID, lux);

			
			while(true) {
				//your code here
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return;
		}

		
	}
	

}
