package com.monnit.mine.MineToCommand;

import com.monnit.mine.MonnitAPN.MNTEventArgs.*;
import com.monnit.mine.MonnitMineAPI.*;
import com.monnit.mine.MonnitMineAPI.enums.eSensorApplication;

public class ResponseHandler implements MineServiceGatewayResponseAccess{

	public static MineServer _Server;
	
	public ResponseHandler(MineServer server) {
		_Server = server;
	}
	
	@Override
	public void ProcessNetworkStatusMessage(NetworkStatusEventArgs args)
			throws Exception {
		
	}

	@Override
	public void ProcessSensorStatusIndicator(SensorStatusEventArgs args)
			throws Exception {
			System.out.println("ProcessSensorStatusIndicator");
			try {
				int SensorID = (int)args.getID();
				System.out.println("    SensorID: " + SensorID);
				if(_Server.FindSensor(SensorID) != null) {
					System.out.println("    Sensor " + SensorID + " already registered.");
					return;
				}
				System.out.println("    Not yet registered.");
				eSensorApplication esa = eSensorApplication.ToApplication(args.getSensorType());
				if(esa != null) {
					System.out.println("    "+esa);
					Sensor sens = new Sensor(
							SensorID,
							esa,
							"2.3.0.0"
							);
					for(Gateway gate : _Server._Gateways.values()) {
						_Server.RegisterSensor(gate.GatewayID, sens);
						System.out.println("    Registered sensor to Gateway " + gate.GatewayID + ".");
					}
				}
				else {
					System.out.println("        Sensor not in map.");
				}
			}
			catch (Exception e) {
				System.out.println(e.toString());
			}
	}

	@Override
	public void ProcessReadDatasectorResponse(ReadConfigEventArgs args)
			throws Exception {
		
	}

	@Override
	public void ProcessWriteDatasectorResponse(WriteConfigEventArgs args)
			throws Exception {
		
	}

	@Override
	public void ProcessAPPCMDResponse(ActionCtrlEventArgs args)
			throws Exception {
		System.out.println("ProcessAPPCMDResponse");
	}

	@Override
	public void ProcessBootloaderResponse(BootloaderEventArgs args)
			throws Exception {
		
	}

	@Override
	public void ProcessParentMsg(ParentMessageEventArgs msg) throws Exception {
		
	}

	@Override
	public void ProcessDataMessage(DataMessageEventArgs msg) throws Exception {
		
	}

}
