package com.monnit.mine.MineToCommand;

import java.util.List;

import com.monnit.mine.BaseApplication.Datum;
import com.monnit.mine.MonnitMineAPI.*;
import com.monnit.mine.MonnitMineAPI.enums.eSensorApplication;

public class SensorMessageHandler implements iSensorMessageHandler {
	public MineServer Server;
		
	public SensorMessageHandler(MineServer server) {
		Server = server;
	}
	
	@Override
	public void ProcessSensorMessages(List<SensorMessage> sensorMessageList, Gateway gateway) throws Exception {
		//System.out.println("Received SensorMessageList.");
		for(SensorMessage msg : sensorMessageList) {
			
			if(msg.SensorID == 502) {
				for(Datum d : msg.getData()) {
					System.out.println(((Double) ((Double)d.Data) * (9.0/5.0) + 32.0) + " F");
				}
				continue;
			}
			else System.out.println(msg.toString());
			
			int SensorID = msg.getSensorID();
			if(Server.FindSensor(SensorID) != null) continue;
						
			int ProfileID = msg.getProfileID();
			eSensorApplication sensApp = eSensorApplication.ToApplication(ProfileID);
			Sensor unknSens = new Sensor(
					SensorID,
					sensApp,
					"2.2.0.0"
					);
			Server.RegisterSensor(gateway.GatewayID, unknSens);
			System.out.println("    Registered reported Sensor:\n        " + SensorID + "\n        " + sensApp);
		}
	}

}
