package com.monnit.mine.MineToCommand;

import java.util.HashMap;

import com.monnit.mine.MonnitMineAPI.Gateway;
import com.monnit.mine.MonnitMineAPI.MineServer;
import com.monnit.mine.MonnitMineAPI.iUnknownGatewayHandler;
import com.monnit.mine.MonnitMineAPI.enums.eGatewayType;

public class UnknownGatewayHandler implements iUnknownGatewayHandler {
	public MineServer Server;
	
	public HashMap<Integer, eGatewayType> gateMap = new HashMap();
	
	public UnknownGatewayHandler(MineServer server) {
		Server = server;
		gateMap.put(9596, eGatewayType.USB);
		gateMap.put(101908, eGatewayType.Ethernet_3_0);
		gateMap.put(101448, eGatewayType.CGW3);
	}
	
	@Override
	public void ProcessUnknownGateway(int GatewayID) {
		eGatewayType egatewaytype = eGatewayType.USB;
		if(gateMap.containsKey(GatewayID)) egatewaytype = gateMap.get(GatewayID);
		
		Gateway newGate = new Gateway(
				GatewayID,
				egatewaytype
				);
		try {
			Server.RegisterGateway(newGate);
			System.out.println("Registered " + egatewaytype.toString() + " gateway " + GatewayID);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
