package com.monnit.mine.MineToCommand;

import java.util.HashMap;

import com.monnit.mine.MonnitMineAPI.Gateway;
import com.monnit.mine.MonnitMineAPI.MineServer;
import com.monnit.mine.MonnitMineAPI.Sensor;
import com.monnit.mine.MonnitMineAPI.iUnknownSensorHandler;
import com.monnit.mine.MonnitMineAPI.enums.eGatewayType;
import com.monnit.mine.MonnitMineAPI.enums.eSensorApplication;

public class UnknownSensorHandler implements iUnknownSensorHandler {
	public MineServer Server;
	
	public HashMap<Integer, eSensorApplication> sensMap = new HashMap();
	
	public UnknownSensorHandler(MineServer server) {
		Server = server;
		sensMap.put(227, eSensorApplication.Light_Detection);
		sensMap.put(19324, eSensorApplication.Control_2_Output);
	}
	
	@Override
	public void ProcessUnknownSensor(int SensorID) {
		try {
			System.out.println("    SensorID: " + SensorID);
			if(Server.FindSensor(SensorID) != null) {
				System.out.println("    Sensor " + SensorID + " already registered.");
				return;
			}
			System.out.println("    Not yet registered.");
			eSensorApplication esa = sensMap.get(SensorID);
			if(esa != null) {
				System.out.println("    "+esa);
				Sensor sens = new Sensor(
						SensorID,
						esa,
						"2.3.0.0"
						);
				for(Gateway gate : Server._Gateways.values()) {
					Server.RegisterSensor(gate.GatewayID, sens);
					System.out.println("    Registered sensor to Gateway " + gate.GatewayID + ".");
				}
			}
			else {
				System.out.println("        Sensor not in map.");
			}
		}
		catch (Exception e) {
			System.out.println(e.toString());
		}
	}
}
